import random

MOD = 10**9


def count_a(start, n, columns):
    min_a = 10 ** 9
    a = 0
    for i in range(n):
        a = max(a, columns[(start + i) % n])
        a += 1
    new_min_a = a - n
    if new_min_a < min_a:
        min_a = new_min_a
    return min_a


def solve_slow(n, columns):
    min_a = 10**9
    g_start = 0
    for start in range(n):
        a = count_a(start, n, columns)
        if a < min_a:
            g_start = start
            min_a = a

    return min_a, g_start + 1


def solve_fast(n, columns):
    max_column = 0
    for i in range(1, n):
        if columns[i] > columns[max_column]:
            max_column = i
    a = columns[max_column]
    break_a = a
    start_index = (max_column + 1) % n + 1
    break_ind = start_index
    for i in range(1, n):
        a -= 1
        index = (max_column - i) % n
        # print(columns[index], index, max_column)
        if columns[index] > a:
            a = columns[index]
        if a < break_a:
            break_a = a
            break_ind = index + 1
        # print(a)
    a = count_a(break_ind-1, n, columns)
    return a, break_ind


def compare():
    for n in range(1, 100):
        cls = [random.randint(1, 1000) for i in range(n)]
        if solve_fast(n, cls) != solve_slow(n, cls):
            print(n, cls)
            print('fast', solve_fast(n, cls))
            print('slow', solve_slow(n, cls))
    print('Compared')


# compare()


def solve():
    n = int(input())
    f = int(input())

    if f == 1:
        columns = [int(i)for i in input().split()]
    else:
        m, x, y, z = [int(i)for i in input().split()]
        columns = [int(i)for i in input().split()] + [0] * (n - m)
        for i in range(m, n):
            columns[i] = ((x * columns[i - 2] + y * columns[i - 1] + z) % MOD) + 1

    # print(columns)
    print(*solve_fast(n, columns))


solve()
